/* ActivatableComponent.c generated by valac 0.48.11, the Vala compiler
 * generated from ActivatableComponent.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define GALA_TYPE_ACTIVATABLE_COMPONENT (gala_activatable_component_get_type ())
#define GALA_ACTIVATABLE_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ACTIVATABLE_COMPONENT, GalaActivatableComponent))
#define GALA_IS_ACTIVATABLE_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ACTIVATABLE_COMPONENT))
#define GALA_ACTIVATABLE_COMPONENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_ACTIVATABLE_COMPONENT, GalaActivatableComponentIface))

typedef struct _GalaActivatableComponent GalaActivatableComponent;
typedef struct _GalaActivatableComponentIface GalaActivatableComponentIface;

struct _GalaActivatableComponentIface {
	GTypeInterface parent_iface;
	void (*open) (GalaActivatableComponent* self, GHashTable* hints);
	void (*close) (GalaActivatableComponent* self);
	gboolean (*is_opened) (GalaActivatableComponent* self);
};

GType gala_activatable_component_get_type (void) G_GNUC_CONST;
void gala_activatable_component_open (GalaActivatableComponent* self,
                                      GHashTable* hints);
void gala_activatable_component_close (GalaActivatableComponent* self);
gboolean gala_activatable_component_is_opened (GalaActivatableComponent* self);
static GType gala_activatable_component_get_type_once (void);

/**
         * The component was requested to be opened.
         *
         * @param hints The hashmap may contain special parameters that are useful
         *              to the component. Currently, the only one implemented is the
         *              'all-windows' hint to the windowoverview.
         */
void
gala_activatable_component_open (GalaActivatableComponent* self,
                                 GHashTable* hints)
{
	g_return_if_fail (self != NULL);
	GALA_ACTIVATABLE_COMPONENT_GET_INTERFACE (self)->open (self, hints);
}

/**
         * The component was requested to be closed.
         */
void
gala_activatable_component_close (GalaActivatableComponent* self)
{
	g_return_if_fail (self != NULL);
	GALA_ACTIVATABLE_COMPONENT_GET_INTERFACE (self)->close (self);
}

/**
         * Should return whether the component is currently opened. Used mainly for
         * toggling by the window manager.
         *
         * @return Return true if the component is opened.
         */
gboolean
gala_activatable_component_is_opened (GalaActivatableComponent* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GALA_ACTIVATABLE_COMPONENT_GET_INTERFACE (self)->is_opened (self);
}

static void
gala_activatable_component_default_init (GalaActivatableComponentIface * iface,
                                         gpointer iface_data)
{
}

/**
     * Implement this interface on your {@link Plugin} class if you want to
     * replace a component like the window overview or the multitasking view.
     * It allows gala to hook up functionality like hotcorners and dbus
     * invocation of your component.
     */
static GType
gala_activatable_component_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaActivatableComponentIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_activatable_component_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gala_activatable_component_type_id;
	gala_activatable_component_type_id = g_type_register_static (G_TYPE_INTERFACE, "GalaActivatableComponent", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gala_activatable_component_type_id, G_TYPE_OBJECT);
	return gala_activatable_component_type_id;
}

GType
gala_activatable_component_get_type (void)
{
	static volatile gsize gala_activatable_component_type_id__volatile = 0;
	if (g_once_init_enter (&gala_activatable_component_type_id__volatile)) {
		GType gala_activatable_component_type_id;
		gala_activatable_component_type_id = gala_activatable_component_get_type_once ();
		g_once_init_leave (&gala_activatable_component_type_id__volatile, gala_activatable_component_type_id);
	}
	return gala_activatable_component_type_id__volatile;
}

