/* AppCache.c generated by valac 0.48.11, the Vala compiler
 * generated from AppCache.vala, do not modify */

/**/
/*  Copyright 2020 elementary, Inc. (https://elementary.io)*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>

#define GALA_TYPE_APP_CACHE (gala_app_cache_get_type ())
#define GALA_APP_CACHE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_APP_CACHE, GalaAppCache))
#define GALA_APP_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_APP_CACHE, GalaAppCacheClass))
#define GALA_IS_APP_CACHE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_APP_CACHE))
#define GALA_IS_APP_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_APP_CACHE))
#define GALA_APP_CACHE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_APP_CACHE, GalaAppCacheClass))

typedef struct _GalaAppCache GalaAppCache;
typedef struct _GalaAppCacheClass GalaAppCacheClass;
typedef struct _GalaAppCachePrivate GalaAppCachePrivate;
enum  {
	GALA_APP_CACHE_0_PROPERTY,
	GALA_APP_CACHE_NUM_PROPERTIES
};
static GParamSpec* gala_app_cache_properties[GALA_APP_CACHE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	GALA_APP_CACHE_CHANGED_SIGNAL,
	GALA_APP_CACHE_NUM_SIGNALS
};
static guint gala_app_cache_signals[GALA_APP_CACHE_NUM_SIGNALS] = {0};

struct _GalaAppCache {
	GObject parent_instance;
	GalaAppCachePrivate * priv;
};

struct _GalaAppCacheClass {
	GObjectClass parent_class;
};

struct _GalaAppCachePrivate {
	GeeHashMap* startup_wm_class_to_id;
	GeeHashMap* id_to_app;
	GAppInfoMonitor* app_info_monitor;
	guint queued_update_id;
};

static gint GalaAppCache_private_offset;
static gpointer gala_app_cache_parent_class = NULL;

GType gala_app_cache_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaAppCache, g_object_unref)
#define GALA_APP_CACHE_DEFAULT_TIMEOUT_SECONDS 3
static void gala_app_cache_queue_cache_update (GalaAppCache* self);
static gboolean __lambda4_ (GalaAppCache* self);
static void gala_app_cache_rebuild_cache (GalaAppCache* self);
static gboolean ___lambda4__gsource_func (gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
GDesktopAppInfo* gala_app_cache_lookup_id (GalaAppCache* self,
                                           const gchar* id);
GDesktopAppInfo* gala_app_cache_lookup_startup_wmclass (GalaAppCache* self,
                                                        const gchar* wm_class);
GalaAppCache* gala_app_cache_new (void);
GalaAppCache* gala_app_cache_construct (GType object_type);
static GObject * gala_app_cache_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _gala_app_cache_queue_cache_update_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                    gpointer self);
static void gala_app_cache_finalize (GObject * obj);
static GType gala_app_cache_get_type_once (void);

static inline gpointer
gala_app_cache_get_instance_private (GalaAppCache* self)
{
	return G_STRUCT_MEMBER_P (self, GalaAppCache_private_offset);
}

static gboolean
__lambda4_ (GalaAppCache* self)
{
	gboolean result = FALSE;
	gala_app_cache_rebuild_cache (self);
	g_signal_emit (self, gala_app_cache_signals[GALA_APP_CACHE_CHANGED_SIGNAL], 0);
	self->priv->queued_update_id = (guint) 0;
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ ((GalaAppCache*) self);
	return result;
}

static void
gala_app_cache_queue_cache_update (GalaAppCache* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->queued_update_id != ((guint) 0)) {
		g_source_remove (self->priv->queued_update_id);
	}
	self->priv->queued_update_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) GALA_APP_CACHE_DEFAULT_TIMEOUT_SECONDS, ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
gala_app_cache_rebuild_cache (GalaAppCache* self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GList* app_infos = NULL;
	GList* _tmp2_;
	GList* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->startup_wm_class_to_id;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	_tmp1_ = self->priv->id_to_app;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
	_tmp2_ = g_app_info_get_all ();
	app_infos = _tmp2_;
	_tmp3_ = app_infos;
	{
		GList* app_collection = NULL;
		GList* app_it = NULL;
		app_collection = _tmp3_;
		for (app_it = app_collection; app_it != NULL; app_it = app_it->next) {
			GAppInfo* app = NULL;
			app = (GAppInfo*) app_it->data;
			{
				gchar* id = NULL;
				GAppInfo* _tmp4_;
				const gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* startup_wm_class = NULL;
				GAppInfo* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				GeeHashMap* _tmp10_;
				const gchar* _tmp11_;
				GAppInfo* _tmp12_;
				const gchar* _tmp13_;
				gchar* old_id = NULL;
				GeeHashMap* _tmp14_;
				const gchar* _tmp15_;
				gpointer _tmp16_;
				gboolean _tmp17_ = FALSE;
				const gchar* _tmp18_;
				_tmp4_ = app;
				_tmp5_ = g_app_info_get_id (_tmp4_);
				_tmp6_ = g_strdup (_tmp5_);
				id = _tmp6_;
				_tmp7_ = app;
				_tmp8_ = g_desktop_app_info_get_startup_wm_class (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, G_TYPE_DESKTOP_APP_INFO, GDesktopAppInfo));
				_tmp9_ = g_strdup (_tmp8_);
				startup_wm_class = _tmp9_;
				_tmp10_ = self->priv->id_to_app;
				_tmp11_ = id;
				_tmp12_ = app;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, _tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, G_TYPE_DESKTOP_APP_INFO, GDesktopAppInfo));
				_tmp13_ = startup_wm_class;
				if (_tmp13_ == NULL) {
					_g_free0 (startup_wm_class);
					_g_free0 (id);
					continue;
				}
				_tmp14_ = self->priv->startup_wm_class_to_id;
				_tmp15_ = startup_wm_class;
				_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, _tmp15_);
				old_id = (gchar*) _tmp16_;
				_tmp18_ = old_id;
				if (_tmp18_ == NULL) {
					_tmp17_ = TRUE;
				} else {
					const gchar* _tmp19_;
					const gchar* _tmp20_;
					_tmp19_ = id;
					_tmp20_ = startup_wm_class;
					_tmp17_ = g_strcmp0 (_tmp19_, _tmp20_) == 0;
				}
				if (_tmp17_) {
					GeeHashMap* _tmp21_;
					const gchar* _tmp22_;
					const gchar* _tmp23_;
					_tmp21_ = self->priv->startup_wm_class_to_id;
					_tmp22_ = startup_wm_class;
					_tmp23_ = id;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, _tmp22_, _tmp23_);
				}
				_g_free0 (old_id);
				_g_free0 (startup_wm_class);
				_g_free0 (id);
			}
		}
	}
	(app_infos == NULL) ? NULL : (app_infos = (_g_list_free__g_object_unref0_ (app_infos), NULL));
}

GDesktopAppInfo*
gala_app_cache_lookup_id (GalaAppCache* self,
                          const gchar* id)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GDesktopAppInfo* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (id == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = self->priv->id_to_app;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, id);
	result = (GDesktopAppInfo*) _tmp1_;
	return result;
}

GDesktopAppInfo*
gala_app_cache_lookup_startup_wmclass (GalaAppCache* self,
                                       const gchar* wm_class)
{
	gchar* id = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	const gchar* _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	gpointer _tmp5_;
	GDesktopAppInfo* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (wm_class == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = self->priv->startup_wm_class_to_id;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, wm_class);
	id = (gchar*) _tmp1_;
	_tmp2_ = id;
	if (_tmp2_ == NULL) {
		result = NULL;
		_g_free0 (id);
		return result;
	}
	_tmp3_ = self->priv->id_to_app;
	_tmp4_ = id;
	_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, _tmp4_);
	result = (GDesktopAppInfo*) _tmp5_;
	_g_free0 (id);
	return result;
}

GalaAppCache*
gala_app_cache_construct (GType object_type)
{
	GalaAppCache * self = NULL;
	self = (GalaAppCache*) g_object_new (object_type, NULL);
	return self;
}

GalaAppCache*
gala_app_cache_new (void)
{
	return gala_app_cache_construct (GALA_TYPE_APP_CACHE);
}

static void
_gala_app_cache_queue_cache_update_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                               gpointer self)
{
	gala_app_cache_queue_cache_update ((GalaAppCache*) self);
}

static GObject *
gala_app_cache_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaAppCache * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GAppInfoMonitor* _tmp2_;
	GAppInfoMonitor* _tmp3_;
	parent_class = G_OBJECT_CLASS (gala_app_cache_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_APP_CACHE, GalaAppCache);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->startup_wm_class_to_id);
	self->priv->startup_wm_class_to_id = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_DESKTOP_APP_INFO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->id_to_app);
	self->priv->id_to_app = _tmp1_;
	_tmp2_ = g_app_info_monitor_get ();
	_g_object_unref0 (self->priv->app_info_monitor);
	self->priv->app_info_monitor = _tmp2_;
	_tmp3_ = self->priv->app_info_monitor;
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _gala_app_cache_queue_cache_update_g_app_info_monitor_changed, self, 0);
	gala_app_cache_rebuild_cache (self);
	return obj;
}

static void
gala_app_cache_class_init (GalaAppCacheClass * klass,
                           gpointer klass_data)
{
	gala_app_cache_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GalaAppCache_private_offset);
	G_OBJECT_CLASS (klass)->constructor = gala_app_cache_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_app_cache_finalize;
	gala_app_cache_signals[GALA_APP_CACHE_CHANGED_SIGNAL] = g_signal_new ("changed", GALA_TYPE_APP_CACHE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
gala_app_cache_instance_init (GalaAppCache * self,
                              gpointer klass)
{
	self->priv = gala_app_cache_get_instance_private (self);
	self->priv->queued_update_id = (guint) 0;
}

static void
gala_app_cache_finalize (GObject * obj)
{
	GalaAppCache * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_APP_CACHE, GalaAppCache);
	_g_object_unref0 (self->priv->startup_wm_class_to_id);
	_g_object_unref0 (self->priv->id_to_app);
	_g_object_unref0 (self->priv->app_info_monitor);
	G_OBJECT_CLASS (gala_app_cache_parent_class)->finalize (obj);
}

static GType
gala_app_cache_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaAppCacheClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_app_cache_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaAppCache), 0, (GInstanceInitFunc) gala_app_cache_instance_init, NULL };
	GType gala_app_cache_type_id;
	gala_app_cache_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaAppCache", &g_define_type_info, 0);
	GalaAppCache_private_offset = g_type_add_instance_private (gala_app_cache_type_id, sizeof (GalaAppCachePrivate));
	return gala_app_cache_type_id;
}

GType
gala_app_cache_get_type (void)
{
	static volatile gsize gala_app_cache_type_id__volatile = 0;
	if (g_once_init_enter (&gala_app_cache_type_id__volatile)) {
		GType gala_app_cache_type_id;
		gala_app_cache_type_id = gala_app_cache_get_type_once ();
		g_once_init_leave (&gala_app_cache_type_id__volatile, gala_app_cache_type_id);
	}
	return gala_app_cache_type_id__volatile;
}

