/* WindowManager.c generated by valac 0.48.11, the Vala compiler
 * generated from WindowManager.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib-object.h>
#include <glib.h>
#include <meta/keybindings.h>
#include <meta/meta-plugin.h>
#include <meta/window.h>
#include <meta/common.h>
#include <clutter/clutter.h>
#include <meta/meta-background-group.h>

typedef enum  {
	GALA_ACTION_TYPE_NONE = 0,
	GALA_ACTION_TYPE_SHOW_WORKSPACE_VIEW,
	GALA_ACTION_TYPE_MAXIMIZE_CURRENT,
	GALA_ACTION_TYPE_MINIMIZE_CURRENT,
	GALA_ACTION_TYPE_OPEN_LAUNCHER,
	GALA_ACTION_TYPE_CUSTOM_COMMAND,
	GALA_ACTION_TYPE_WINDOW_OVERVIEW,
	GALA_ACTION_TYPE_WINDOW_OVERVIEW_ALL,
	GALA_ACTION_TYPE_SWITCH_TO_WORKSPACE_LAST,
	GALA_ACTION_TYPE_START_MOVE_CURRENT,
	GALA_ACTION_TYPE_START_RESIZE_CURRENT,
	GALA_ACTION_TYPE_TOGGLE_ALWAYS_ON_TOP_CURRENT,
	GALA_ACTION_TYPE_TOGGLE_ALWAYS_ON_VISIBLE_WORKSPACE_CURRENT,
	GALA_ACTION_TYPE_MOVE_CURRENT_WORKSPACE_LEFT,
	GALA_ACTION_TYPE_MOVE_CURRENT_WORKSPACE_RIGHT,
	GALA_ACTION_TYPE_CLOSE_CURRENT
} GalaActionType;

#define GALA_TYPE_ACTION_TYPE (gala_action_type_get_type ())
typedef enum  {
	GALA_WINDOW_FLAGS_NONE = 0,
	GALA_WINDOW_FLAGS_CAN_MINIMIZE = 1 << 0,
	GALA_WINDOW_FLAGS_CAN_MAXIMIZE = 1 << 1,
	GALA_WINDOW_FLAGS_IS_MAXIMIZED = 1 << 2,
	GALA_WINDOW_FLAGS_ALLOWS_MOVE = 1 << 3,
	GALA_WINDOW_FLAGS_ALLOWS_RESIZE = 1 << 4,
	GALA_WINDOW_FLAGS_ALWAYS_ON_TOP = 1 << 5,
	GALA_WINDOW_FLAGS_ON_ALL_WORKSPACES = 1 << 6,
	GALA_WINDOW_FLAGS_CAN_CLOSE = 1 << 7
} GalaWindowFlags;

#define GALA_TYPE_WINDOW_FLAGS (gala_window_flags_get_type ())
typedef gboolean (*GalaKeybindingFilter) (MetaKeyBinding* binding, gpointer user_data);

#define GALA_TYPE_MODAL_PROXY (gala_modal_proxy_get_type ())
#define GALA_MODAL_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_MODAL_PROXY, GalaModalProxy))
#define GALA_MODAL_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_MODAL_PROXY, GalaModalProxyClass))
#define GALA_IS_MODAL_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_MODAL_PROXY))
#define GALA_IS_MODAL_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_MODAL_PROXY))
#define GALA_MODAL_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_MODAL_PROXY, GalaModalProxyClass))

typedef struct _GalaModalProxy GalaModalProxy;
typedef struct _GalaModalProxyClass GalaModalProxyClass;
typedef struct _GalaModalProxyPrivate GalaModalProxyPrivate;
enum  {
	GALA_MODAL_PROXY_0_PROPERTY,
	GALA_MODAL_PROXY_NUM_PROPERTIES
};
static GParamSpec* gala_modal_proxy_properties[GALA_MODAL_PROXY_NUM_PROPERTIES];

#define GALA_TYPE_WINDOW_MANAGER (gala_window_manager_get_type ())
#define GALA_WINDOW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_MANAGER, GalaWindowManager))
#define GALA_IS_WINDOW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_MANAGER))
#define GALA_WINDOW_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_WINDOW_MANAGER, GalaWindowManagerIface))

typedef struct _GalaWindowManager GalaWindowManager;
typedef struct _GalaWindowManagerIface GalaWindowManagerIface;

struct _GalaModalProxy {
	GObject parent_instance;
	GalaModalProxyPrivate * priv;
};

struct _GalaModalProxyClass {
	GObjectClass parent_class;
};

struct _GalaModalProxyPrivate {
	GalaKeybindingFilter _keybinding_filter;
	gpointer _keybinding_filter_target;
	GDestroyNotify _keybinding_filter_target_destroy_notify;
};

struct _GalaWindowManagerIface {
	GTypeInterface parent_iface;
	GalaModalProxy* (*push_modal) (GalaWindowManager* self);
	void (*pop_modal) (GalaWindowManager* self, GalaModalProxy* proxy);
	gboolean (*is_modal) (GalaWindowManager* self);
	gboolean (*modal_proxy_valid) (GalaWindowManager* self, GalaModalProxy* proxy);
	void (*perform_action) (GalaWindowManager* self, GalaActionType type);
	void (*move_window) (GalaWindowManager* self, MetaWindow* window, MetaMotionDirection direction);
	void (*switch_to_next_workspace) (GalaWindowManager* self, MetaMotionDirection direction);
	ClutterActor* (*get_ui_group) (GalaWindowManager* self);
	void (*set_ui_group) (GalaWindowManager* self, ClutterActor* value);
	ClutterStage* (*get_stage) (GalaWindowManager* self);
	void (*set_stage) (GalaWindowManager* self, ClutterStage* value);
	ClutterActor* (*get_window_group) (GalaWindowManager* self);
	void (*set_window_group) (GalaWindowManager* self, ClutterActor* value);
	ClutterActor* (*get_top_window_group) (GalaWindowManager* self);
	void (*set_top_window_group) (GalaWindowManager* self, ClutterActor* value);
	MetaBackgroundGroup* (*get_background_group) (GalaWindowManager* self);
	void (*set_background_group) (GalaWindowManager* self, MetaBackgroundGroup* value);
	gboolean (*get_enable_animations) (GalaWindowManager* self);
	void (*set_enable_animations) (GalaWindowManager* self, gboolean value);
};

static gint GalaModalProxy_private_offset;
static gpointer gala_modal_proxy_parent_class = NULL;

GType gala_action_type_get_type (void) G_GNUC_CONST;
GType gala_window_flags_get_type (void) G_GNUC_CONST;
GType gala_modal_proxy_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaModalProxy, g_object_unref)
static gboolean _gala_modal_proxy__keybinding_filter_lambda5_ (void);
static gboolean __gala_modal_proxy__keybinding_filter_lambda5__gala_keybinding_filter (MetaKeyBinding* binding,
                                                                                gpointer self);
GalaModalProxy* gala_modal_proxy_new (void);
GalaModalProxy* gala_modal_proxy_construct (GType object_type);
void gala_modal_proxy_allow_all_keybindings (GalaModalProxy* self);
void gala_modal_proxy_set_keybinding_filter (GalaModalProxy* self,
                                             GalaKeybindingFilter value,
                                             gpointer value_target,
                                             GDestroyNotify value_target_destroy_notify);
GalaKeybindingFilter gala_modal_proxy_get_keybinding_filter (GalaModalProxy* self,
                                                             gpointer* result_target);
static void gala_modal_proxy_finalize (GObject * obj);
static GType gala_modal_proxy_get_type_once (void);
static void _vala_gala_modal_proxy_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_gala_modal_proxy_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
GType gala_window_manager_get_type (void) G_GNUC_CONST;
GalaModalProxy* gala_window_manager_push_modal (GalaWindowManager* self);
void gala_window_manager_pop_modal (GalaWindowManager* self,
                                    GalaModalProxy* proxy);
gboolean gala_window_manager_is_modal (GalaWindowManager* self);
gboolean gala_window_manager_modal_proxy_valid (GalaWindowManager* self,
                                                GalaModalProxy* proxy);
void gala_window_manager_perform_action (GalaWindowManager* self,
                                         GalaActionType type);
void gala_window_manager_move_window (GalaWindowManager* self,
                                      MetaWindow* window,
                                      MetaMotionDirection direction);
void gala_window_manager_switch_to_next_workspace (GalaWindowManager* self,
                                                   MetaMotionDirection direction);
ClutterActor* gala_window_manager_get_ui_group (GalaWindowManager* self);
void gala_window_manager_set_ui_group (GalaWindowManager* self,
                                       ClutterActor* value);
ClutterStage* gala_window_manager_get_stage (GalaWindowManager* self);
void gala_window_manager_set_stage (GalaWindowManager* self,
                                    ClutterStage* value);
ClutterActor* gala_window_manager_get_window_group (GalaWindowManager* self);
void gala_window_manager_set_window_group (GalaWindowManager* self,
                                           ClutterActor* value);
ClutterActor* gala_window_manager_get_top_window_group (GalaWindowManager* self);
void gala_window_manager_set_top_window_group (GalaWindowManager* self,
                                               ClutterActor* value);
MetaBackgroundGroup* gala_window_manager_get_background_group (GalaWindowManager* self);
void gala_window_manager_set_background_group (GalaWindowManager* self,
                                               MetaBackgroundGroup* value);
gboolean gala_window_manager_get_enable_animations (GalaWindowManager* self);
void gala_window_manager_set_enable_animations (GalaWindowManager* self,
                                                gboolean value);
static GType gala_window_manager_get_type_once (void);

static GType
gala_action_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_ACTION_TYPE_NONE, "GALA_ACTION_TYPE_NONE", "none"}, {GALA_ACTION_TYPE_SHOW_WORKSPACE_VIEW, "GALA_ACTION_TYPE_SHOW_WORKSPACE_VIEW", "show-workspace-view"}, {GALA_ACTION_TYPE_MAXIMIZE_CURRENT, "GALA_ACTION_TYPE_MAXIMIZE_CURRENT", "maximize-current"}, {GALA_ACTION_TYPE_MINIMIZE_CURRENT, "GALA_ACTION_TYPE_MINIMIZE_CURRENT", "minimize-current"}, {GALA_ACTION_TYPE_OPEN_LAUNCHER, "GALA_ACTION_TYPE_OPEN_LAUNCHER", "open-launcher"}, {GALA_ACTION_TYPE_CUSTOM_COMMAND, "GALA_ACTION_TYPE_CUSTOM_COMMAND", "custom-command"}, {GALA_ACTION_TYPE_WINDOW_OVERVIEW, "GALA_ACTION_TYPE_WINDOW_OVERVIEW", "window-overview"}, {GALA_ACTION_TYPE_WINDOW_OVERVIEW_ALL, "GALA_ACTION_TYPE_WINDOW_OVERVIEW_ALL", "window-overview-all"}, {GALA_ACTION_TYPE_SWITCH_TO_WORKSPACE_LAST, "GALA_ACTION_TYPE_SWITCH_TO_WORKSPACE_LAST", "switch-to-workspace-last"}, {GALA_ACTION_TYPE_START_MOVE_CURRENT, "GALA_ACTION_TYPE_START_MOVE_CURRENT", "start-move-current"}, {GALA_ACTION_TYPE_START_RESIZE_CURRENT, "GALA_ACTION_TYPE_START_RESIZE_CURRENT", "start-resize-current"}, {GALA_ACTION_TYPE_TOGGLE_ALWAYS_ON_TOP_CURRENT, "GALA_ACTION_TYPE_TOGGLE_ALWAYS_ON_TOP_CURRENT", "toggle-always-on-top-current"}, {GALA_ACTION_TYPE_TOGGLE_ALWAYS_ON_VISIBLE_WORKSPACE_CURRENT, "GALA_ACTION_TYPE_TOGGLE_ALWAYS_ON_VISIBLE_WORKSPACE_CURRENT", "toggle-always-on-visible-workspace-current"}, {GALA_ACTION_TYPE_MOVE_CURRENT_WORKSPACE_LEFT, "GALA_ACTION_TYPE_MOVE_CURRENT_WORKSPACE_LEFT", "move-current-workspace-left"}, {GALA_ACTION_TYPE_MOVE_CURRENT_WORKSPACE_RIGHT, "GALA_ACTION_TYPE_MOVE_CURRENT_WORKSPACE_RIGHT", "move-current-workspace-right"}, {GALA_ACTION_TYPE_CLOSE_CURRENT, "GALA_ACTION_TYPE_CLOSE_CURRENT", "close-current"}, {0, NULL, NULL}};
	GType gala_action_type_type_id;
	gala_action_type_type_id = g_enum_register_static ("GalaActionType", values);
	return gala_action_type_type_id;
}

GType
gala_action_type_get_type (void)
{
	static volatile gsize gala_action_type_type_id__volatile = 0;
	if (g_once_init_enter (&gala_action_type_type_id__volatile)) {
		GType gala_action_type_type_id;
		gala_action_type_type_id = gala_action_type_get_type_once ();
		g_once_init_leave (&gala_action_type_type_id__volatile, gala_action_type_type_id);
	}
	return gala_action_type_type_id__volatile;
}

static GType
gala_window_flags_get_type_once (void)
{
	static const GFlagsValue values[] = {{GALA_WINDOW_FLAGS_NONE, "GALA_WINDOW_FLAGS_NONE", "none"}, {GALA_WINDOW_FLAGS_CAN_MINIMIZE, "GALA_WINDOW_FLAGS_CAN_MINIMIZE", "can-minimize"}, {GALA_WINDOW_FLAGS_CAN_MAXIMIZE, "GALA_WINDOW_FLAGS_CAN_MAXIMIZE", "can-maximize"}, {GALA_WINDOW_FLAGS_IS_MAXIMIZED, "GALA_WINDOW_FLAGS_IS_MAXIMIZED", "is-maximized"}, {GALA_WINDOW_FLAGS_ALLOWS_MOVE, "GALA_WINDOW_FLAGS_ALLOWS_MOVE", "allows-move"}, {GALA_WINDOW_FLAGS_ALLOWS_RESIZE, "GALA_WINDOW_FLAGS_ALLOWS_RESIZE", "allows-resize"}, {GALA_WINDOW_FLAGS_ALWAYS_ON_TOP, "GALA_WINDOW_FLAGS_ALWAYS_ON_TOP", "always-on-top"}, {GALA_WINDOW_FLAGS_ON_ALL_WORKSPACES, "GALA_WINDOW_FLAGS_ON_ALL_WORKSPACES", "on-all-workspaces"}, {GALA_WINDOW_FLAGS_CAN_CLOSE, "GALA_WINDOW_FLAGS_CAN_CLOSE", "can-close"}, {0, NULL, NULL}};
	GType gala_window_flags_type_id;
	gala_window_flags_type_id = g_flags_register_static ("GalaWindowFlags", values);
	return gala_window_flags_type_id;
}

GType
gala_window_flags_get_type (void)
{
	static volatile gsize gala_window_flags_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_flags_type_id__volatile)) {
		GType gala_window_flags_type_id;
		gala_window_flags_type_id = gala_window_flags_get_type_once ();
		g_once_init_leave (&gala_window_flags_type_id__volatile, gala_window_flags_type_id);
	}
	return gala_window_flags_type_id__volatile;
}

static inline gpointer
gala_modal_proxy_get_instance_private (GalaModalProxy* self)
{
	return G_STRUCT_MEMBER_P (self, GalaModalProxy_private_offset);
}

static gboolean
_gala_modal_proxy__keybinding_filter_lambda5_ (void)
{
	gboolean result = FALSE;
	result = TRUE;
	return result;
}

static gboolean
__gala_modal_proxy__keybinding_filter_lambda5__gala_keybinding_filter (MetaKeyBinding* binding,
                                                                       gpointer self)
{
	gboolean result;
	result = _gala_modal_proxy__keybinding_filter_lambda5_ ();
	return result;
}

GalaModalProxy*
gala_modal_proxy_construct (GType object_type)
{
	GalaModalProxy * self = NULL;
	self = (GalaModalProxy*) g_object_new (object_type, NULL);
	return self;
}

GalaModalProxy*
gala_modal_proxy_new (void)
{
	return gala_modal_proxy_construct (GALA_TYPE_MODAL_PROXY);
}

/**
         * Small utility to allow all keybindings
         */
void
gala_modal_proxy_allow_all_keybindings (GalaModalProxy* self)
{
	g_return_if_fail (self != NULL);
	gala_modal_proxy_set_keybinding_filter (self, NULL, NULL, NULL);
}

GalaKeybindingFilter
gala_modal_proxy_get_keybinding_filter (GalaModalProxy* self,
                                        gpointer* result_target)
{
	GalaKeybindingFilter result;
	GalaKeybindingFilter _tmp0_;
	gpointer _tmp0__target;
	GalaKeybindingFilter _tmp1_;
	gpointer _tmp1__target;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_keybinding_filter;
	_tmp0__target = self->priv->_keybinding_filter_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}

void
gala_modal_proxy_set_keybinding_filter (GalaModalProxy* self,
                                        GalaKeybindingFilter value,
                                        gpointer value_target,
                                        GDestroyNotify value_target_destroy_notify)
{
	GalaKeybindingFilter _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp0__target = value_target;
	_tmp0__target_destroy_notify = value_target_destroy_notify;
	value = NULL;
	value_target = NULL;
	value_target_destroy_notify = NULL;
	(self->priv->_keybinding_filter_target_destroy_notify == NULL) ? NULL : (self->priv->_keybinding_filter_target_destroy_notify (self->priv->_keybinding_filter_target), NULL);
	self->priv->_keybinding_filter = NULL;
	self->priv->_keybinding_filter_target = NULL;
	self->priv->_keybinding_filter_target_destroy_notify = NULL;
	self->priv->_keybinding_filter = _tmp0_;
	self->priv->_keybinding_filter_target = _tmp0__target;
	self->priv->_keybinding_filter_target_destroy_notify = _tmp0__target_destroy_notify;
	(value_target_destroy_notify == NULL) ? NULL : (value_target_destroy_notify (value_target), NULL);
	value = NULL;
	value_target = NULL;
	value_target_destroy_notify = NULL;
}

static void
gala_modal_proxy_class_init (GalaModalProxyClass * klass,
                             gpointer klass_data)
{
	gala_modal_proxy_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GalaModalProxy_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_modal_proxy_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_modal_proxy_set_property;
	G_OBJECT_CLASS (klass)->finalize = gala_modal_proxy_finalize;
}

static void
gala_modal_proxy_instance_init (GalaModalProxy * self,
                                gpointer klass)
{
	self->priv = gala_modal_proxy_get_instance_private (self);
	self->priv->_keybinding_filter = __gala_modal_proxy__keybinding_filter_lambda5__gala_keybinding_filter;
	self->priv->_keybinding_filter_target = self;
	self->priv->_keybinding_filter_target_destroy_notify = NULL;
}

static void
gala_modal_proxy_finalize (GObject * obj)
{
	GalaModalProxy * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_MODAL_PROXY, GalaModalProxy);
	(self->priv->_keybinding_filter_target_destroy_notify == NULL) ? NULL : (self->priv->_keybinding_filter_target_destroy_notify (self->priv->_keybinding_filter_target), NULL);
	self->priv->_keybinding_filter = NULL;
	self->priv->_keybinding_filter_target = NULL;
	self->priv->_keybinding_filter_target_destroy_notify = NULL;
	G_OBJECT_CLASS (gala_modal_proxy_parent_class)->finalize (obj);
}

/**
     * A minimal class mostly used to identify your call to {@link WindowManager.push_modal} and used
     * to end your modal mode again with {@link WindowManager.pop_modal}
     */
static GType
gala_modal_proxy_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaModalProxyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_modal_proxy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaModalProxy), 0, (GInstanceInitFunc) gala_modal_proxy_instance_init, NULL };
	GType gala_modal_proxy_type_id;
	gala_modal_proxy_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaModalProxy", &g_define_type_info, 0);
	GalaModalProxy_private_offset = g_type_add_instance_private (gala_modal_proxy_type_id, sizeof (GalaModalProxyPrivate));
	return gala_modal_proxy_type_id;
}

GType
gala_modal_proxy_get_type (void)
{
	static volatile gsize gala_modal_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&gala_modal_proxy_type_id__volatile)) {
		GType gala_modal_proxy_type_id;
		gala_modal_proxy_type_id = gala_modal_proxy_get_type_once ();
		g_once_init_leave (&gala_modal_proxy_type_id__volatile, gala_modal_proxy_type_id);
	}
	return gala_modal_proxy_type_id__volatile;
}

static void
_vala_gala_modal_proxy_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	GalaModalProxy * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_MODAL_PROXY, GalaModalProxy);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gala_modal_proxy_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	GalaModalProxy * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_MODAL_PROXY, GalaModalProxy);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

/**
         * Enters the modal mode, which means that all events are directed to the stage instead
         * of the windows. This is the only way to receive keyboard events besides shortcut listeners.
         *
         * @return a {@link ModalProxy} which is needed to end the modal mode again and provides some
         *         some basic control on the behavior of the window manager while it is in modal mode.
         */
GalaModalProxy*
gala_window_manager_push_modal (GalaWindowManager* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->push_modal (self);
}

/**
         * May exit the modal mode again, unless another component has called {@link push_modal}
         *
         * @param proxy The {@link ModalProxy} received from {@link push_modal}
         */
void
gala_window_manager_pop_modal (GalaWindowManager* self,
                               GalaModalProxy* proxy)
{
	g_return_if_fail (self != NULL);
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->pop_modal (self, proxy);
}

/**
         * Returns whether the window manager is currently in modal mode.
         * @see push_modal
         */
gboolean
gala_window_manager_is_modal (GalaWindowManager* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->is_modal (self);
}

/**
         * Tests if a given {@link ModalProxy} is valid and may be popped. Should not be necessary
         * to use this function in most cases, but it may be helpful for debugging. Gala catches
         * invalid proxies as well and emits a warning in that case.
         *
         * @param proxy The {@link ModalProxy} to check
         * @return      Returns true if the prox is valid
         */
gboolean
gala_window_manager_modal_proxy_valid (GalaWindowManager* self,
                                       GalaModalProxy* proxy)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->modal_proxy_valid (self, proxy);
}

/**
         * Tells the window manager to perform the given action.
         *
         * @param type The type of action to perform
         */
void
gala_window_manager_perform_action (GalaWindowManager* self,
                                    GalaActionType type)
{
	g_return_if_fail (self != NULL);
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->perform_action (self, type);
}

/**
         * Moves the window to the workspace next to its current workspace in the given direction.
         * Gala currently only supports LEFT and RIGHT.
         *
         * @param window    The window to be moved
         * @param direction The direction in which to move the window
         */
void
gala_window_manager_move_window (GalaWindowManager* self,
                                 MetaWindow* window,
                                 MetaMotionDirection direction)
{
	g_return_if_fail (self != NULL);
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->move_window (self, window, direction);
}

/**
         * Switches to the next workspace in the given direction.
         *
         * @param direction The direction in which to switch
         */
void
gala_window_manager_switch_to_next_workspace (GalaWindowManager* self,
                                              MetaMotionDirection direction)
{
	g_return_if_fail (self != NULL);
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->switch_to_next_workspace (self, direction);
}

ClutterActor*
gala_window_manager_get_ui_group (GalaWindowManager* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_ui_group (self);
}

void
gala_window_manager_set_ui_group (GalaWindowManager* self,
                                  ClutterActor* value)
{
	g_return_if_fail (self != NULL);
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_ui_group (self, value);
}

ClutterStage*
gala_window_manager_get_stage (GalaWindowManager* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_stage (self);
}

void
gala_window_manager_set_stage (GalaWindowManager* self,
                               ClutterStage* value)
{
	g_return_if_fail (self != NULL);
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_stage (self, value);
}

ClutterActor*
gala_window_manager_get_window_group (GalaWindowManager* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_window_group (self);
}

void
gala_window_manager_set_window_group (GalaWindowManager* self,
                                      ClutterActor* value)
{
	g_return_if_fail (self != NULL);
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_window_group (self, value);
}

ClutterActor*
gala_window_manager_get_top_window_group (GalaWindowManager* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_top_window_group (self);
}

void
gala_window_manager_set_top_window_group (GalaWindowManager* self,
                                          ClutterActor* value)
{
	g_return_if_fail (self != NULL);
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_top_window_group (self, value);
}

MetaBackgroundGroup*
gala_window_manager_get_background_group (GalaWindowManager* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_background_group (self);
}

void
gala_window_manager_set_background_group (GalaWindowManager* self,
                                          MetaBackgroundGroup* value)
{
	g_return_if_fail (self != NULL);
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_background_group (self, value);
}

gboolean
gala_window_manager_get_enable_animations (GalaWindowManager* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_enable_animations (self);
}

void
gala_window_manager_set_enable_animations (GalaWindowManager* self,
                                           gboolean value)
{
	g_return_if_fail (self != NULL);
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_enable_animations (self, value);
}

static void
gala_window_manager_default_init (GalaWindowManagerIface * iface,
                                  gpointer iface_data)
{
	/**
	         * This is the container you'll most likely want to add your component to. It wraps
	         * every other container listed in this interface and is a direct child of the stage.
	         */
	g_object_interface_install_property (iface, g_param_spec_object ("ui-group", "ui-group", "ui-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * The stage of the window manager
	         */
	g_object_interface_install_property (iface, g_param_spec_object ("stage", "stage", "stage", clutter_stage_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * A group containting all 'usual' windows
	         * @see top_window_group
	         */
	g_object_interface_install_property (iface, g_param_spec_object ("window-group", "window-group", "window-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * The top window group contains special windows that are always placed on top
	         * like fullscreen windows.
	         */
	g_object_interface_install_property (iface, g_param_spec_object ("top-window-group", "top-window-group", "top-window-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * The background group is a container for the background actors forming the wallpaper
	         */
	g_object_interface_install_property (iface, g_param_spec_object ("background-group", "background-group", "background-group", meta_background_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Whether animations should be displayed.
	         */
	g_object_interface_install_property (iface, g_param_spec_boolean ("enable-animations", "enable-animations", "enable-animations", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static GType
gala_window_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowManagerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_manager_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gala_window_manager_type_id;
	gala_window_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "GalaWindowManager", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gala_window_manager_type_id, meta_plugin_get_type ());
	return gala_window_manager_type_id;
}

GType
gala_window_manager_get_type (void)
{
	static volatile gsize gala_window_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_manager_type_id__volatile)) {
		GType gala_window_manager_type_id;
		gala_window_manager_type_id = gala_window_manager_get_type_once ();
		g_once_init_leave (&gala_window_manager_type_id__volatile, gala_window_manager_type_id);
	}
	return gala_window_manager_type_id__volatile;
}

